/* UTCDialog.cls */

USING System.Windows.Forms.* FROM ASSEMBLY.
 
CLASS UTCDialog INHERITS Progress.Windows.Form: 

  DEFINE PRIVATE VARIABLE buttonTZ AS Button NO-UNDO.
  DEFINE PRIVATE VARIABLE buttonOk AS Button NO-UNDO.
  DEFINE PRIVATE VARIABLE labelTZ AS Label NO-UNDO.
  DEFINE PRIVATE VARIABLE lUTCSelected AS LOGICAL NO-UNDO.
  
  METHOD PUBLIC VOID WaitForDialog ( INPUT pForm AS CLASS UTCSelectForm,
                                     OUTPUT pResult AS CLASS DialogResult ):
    WAIT-FOR THIS-OBJECT:ShowDialog( pForm ) SET pResult.
  END METHOD.

  CONSTRUCTOR PUBLIC UTCDialog ( INPUT pUTCSelected AS LOGICAL ):
    lUTCSelected = pUTCSelected.
    InitializeComponent( ).
  END CONSTRUCTOR.

  METHOD PRIVATE VOID InitializeComponent ( ):
    
    buttonTZ = NEW Button ( ).
    buttonOk = NEW Button ( ).
    labelTZ = NEW Label ( ).

    THIS-OBJECT:SuspendLayout ( ).
 
    IF lUTCSelected
    THEN 
      labelTZ:Text = "UTC Time Zone".
    ELSE
      labelTZ:Text = "Eastern Standard Time Zone".
    labelTZ:Size = TextRenderer:MeasureText( labelTZ:Text, labelTZ:Font ).
    labelTZ:Size = NEW System.Drawing.Size( INTEGER(labelTZ:Width * 1.1 ),
                                            INTEGER(labelTZ:Height * 1.6 ) ).
    labelTZ:Top = 20.

    buttonTZ:Text = "UTC or EST?".
    buttonTZ:TabIndex = 0.
    buttonTZ:Size = NEW System.Drawing.Size ( INTEGER(buttonTZ:Width * 1.2), 
                                              23 ).
    buttonTZ:Anchor = System.Windows.Forms.AnchorStyles:Bottom.
    buttonTZ:Top = 20 + labelTZ:Height + 10.
    buttonTZ:Click:Subscribe( tzButton_Click ).

    buttonOk:Text = "OK".
    buttonOk:TabIndex = 1.
    buttonOk:Size = NEW System.Drawing.Size ( INTEGER(buttonOk:Width * 1.1), 
                                              23 ).
    buttonOk:Anchor = System.Windows.Forms.AnchorStyles:Bottom.
    buttonOk:Top = buttonTZ:Top.
    buttonOk:Click:Subscribe( okButton_Click ).

    THIS-OBJECT:Text = "Select UTC or Eastern Standard Time".
    THIS-OBJECT:AcceptButton = buttonOk.
    THIS-OBJECT:ClientSize = NEW System.Drawing.Size( (buttonTZ:Width + buttonOK:Width) * 2, 
                                                      labelTZ:Height + buttonTZ:Height + 40 ).
    THIS-OBJECT:Controls:Add( labelTZ ).
    THIS-OBJECT:Controls:Add( buttonTZ ).
    THIS-OBJECT:Controls:Add( buttonOk ).
    labelTZ:Left = (THIS-OBJECT:Width - labelTZ:Width) / 2.
    buttonTZ:Left = (THIS-OBJECT:Width - (buttonTZ:Width + buttonOk:Width + 10 )) / 2.
    buttonOk:Left = buttonTZ:Left + buttonTZ:Width + 10.
    THIS-OBJECT:FormBorderStyle = FormBorderStyle:FixedDialog.
    THIS-OBJECT:MaximizeBox = FALSE.
    THIS-OBJECT:MinimizeBox = FALSE.
    THIS-OBJECT:ShowInTaskbar = FALSE.
    THIS-OBJECT:StartPosition = FormStartPosition:CenterParent.
    
    THIS-OBJECT:ResumeLayout (FALSE).

  END METHOD.
 
  METHOD PRIVATE VOID okButton_Click (sender AS System.Object, 
                                      e AS System.EventArgs):
    IF lUTCSelected
    THEN 
      THIS-OBJECT:DialogResult = DialogResult:Yes.
    ELSE 
      THIS-OBJECT:DialogResult = DialogResult:No.
    THIS-OBJECT:Close ( ).
  END METHOD.
   
  METHOD PRIVATE VOID tzButton_Click (sender AS System.Object, 
                                      e AS System.EventArgs):
    IF lUTCSelected
    THEN DO:
      lUTCSelected = FALSE.
      labelTZ:Text = "Eastern Standard Time Zone".
    END.
    ELSE DO:
      lUTCSelected = TRUE.
      labelTZ:Text = "UTC Time Zone".
    END.
    labelTZ:Size = TextRenderer:MeasureText( labelTZ:Text, labelTZ:Font ).
    labelTZ:Size = NEW System.Drawing.Size( INTEGER(labelTZ:Width * 1.1 ),
                                            INTEGER(labelTZ:Height * 1.6 ) ).
    labelTZ:Left = (THIS-OBJECT:Width - labelTZ:Width) / 2.
  END METHOD.

END CLASS.
