&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : datacustom.p
    Purpose     : Super procedure to extend data class.

    Syntax      : datacustom.p

    Modified    : 06/03/1999
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper datacustom.p

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 4.71
         WIDTH              = 48.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm2/dataprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-initializeObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject Procedure 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Custom version of initializeObject to filter all Customers
               by matching SalesRep to the current User Name.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE VARIABLE dUserObj     AS DECIMAL    NO-UNDO.
DEFINE VARIABLE cUserLogin   AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cProperties  AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cTables      AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hTable       AS HANDLE     NO-UNDO.
DEFINE VARIABLE hField       AS HANDLE     NO-UNDO.
DEFINE VARIABLE cPrivileged  AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cOpenQuery   AS CHARACTER  NO-UNDO.

  cProperties = DYNAMIC-FUNCTION ('getPropertyList' IN gshSessionManager,
      'currentUserObj,currentUserLogin', NO).
  ASSIGN dUserObj =   DECIMAL(ENTRY(1, cProperties, CHR(3)))
         cUserLogin = ENTRY(2, cProperties, CHR(3)).

  {get Tables cTables}.
  IF cTables NE "":U THEN      /* May be blank on init */
  DO:
      RUN getEntityDescription IN gshGenManager 
          ( INPUT    'gsmus', 
            INPUT     dUserObj,
            INPUT     'maintain_system_data',
            OUTPUT    cPrivileged ).
      IF cPrivileged = 'NO' THEN 
      DO:
          
        CREATE BUFFER hTable FOR TABLE ENTRY(1,cTables).
        hField = hTable:BUFFER-FIELD('SalesRep') NO-ERROR.
        IF VALID-HANDLE(hField) THEN
        DO:
            DYNAMIC-FUNCTION('assignQuerySelection' IN TARGET-PROCEDURE,
                             "SalesRep", cUserLogin, "").
            {get QueryString cOpenQuery}.
            {set OpenQuery cOpenQuery}.
        END.
        DELETE OBJECT hTable.
      END.   /* IF NOT privileged */
  END.       /* If the Tables are defined */
  
  RUN SUPER.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

