&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : visualcustom.p
    Purpose     : Super procedure to extend visual class.

    Syntax      : visualcustom.p

    Modified    : 06/03/1999
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper visualcustom.p

DEFINE VARIABLE gcFieldDelim AS CHARACTER  NO-UNDO /* REMEMBER TO SET THIS */
    INIT ",".
DEFINE VARIABLE gcValueDelim AS CHARACTER  NO-UNDO /* AND THIS */
    INIT "|".

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-disableWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD disableWidget Procedure 
FUNCTION disableWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-enableWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD enableWidget Procedure 
FUNCTION enableWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-hideWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD hideWidget Procedure 
FUNCTION hideWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-highlightWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD highlightWidget Procedure 
FUNCTION highlightWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER, INPUT pcHighlightType AS CHARACTER)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setWidgetDelimiter) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setWidgetDelimiter Procedure 
FUNCTION setWidgetDelimiter RETURNS LOGICAL
  ( INPUT pcType AS CHARACTER, INPUT pcDelim AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-viewWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD viewWidget Procedure 
FUNCTION viewWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD widgetHandle Procedure 
FUNCTION widgetHandle RETURNS HANDLE
  ( pcWidget AS CHARACTER, phTarget AS HANDLE )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetModified) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD widgetModified Procedure 
FUNCTION widgetModified RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD widgetValue Procedure 
FUNCTION widgetValue RETURNS CHARACTER
  ( pcFieldList AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 3
         WIDTH              = 49.4.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm2/visprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-disableWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION disableWidget Procedure 
FUNCTION disableWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Disables the object or objects in the FieldList.
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  
------------------------------------------------------------------------------*/
  
DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
DEFINE VARIABLE lInvalid  AS LOGICAL    NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF VALID-HANDLE(hField) THEN
      DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Use its DataModified property. */
          {set EnableField NO hField}.
        ELSE IF CAN-SET(hField, "SENSITIVE") THEN
              hField:SENSITIVE = NO.
        ELSE lInvalid = YES.
      END.    /* END ELSE DO IF VALID-HANDLE */
      
      ELSE lInvalid = YES.
  END.        /* END DO iField */

  /* Return FALSE if any field was invalid. */
  RETURN NOT lInvalid.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-enableWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION enableWidget Procedure 
FUNCTION enableWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Enables the object or objects in the FieldList.
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  
------------------------------------------------------------------------------*/
  
DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
DEFINE VARIABLE lInvalid  AS LOGICAL    NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF VALID-HANDLE(hField) THEN
      DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Use its DataModified property. */
          {set EnableField YES hField}.
        ELSE IF CAN-SET(hField, "SENSITIVE") THEN
              hField:SENSITIVE = YES.
        ELSE lInvalid = YES.
      END.    /* END ELSE DO IF VALID-HANDLE */
      ELSE lInvalid = YES.
  END.        /* END DO iField */

  /* Return FALSE if any field was invalid. */
  RETURN NOT lInvalid.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-hideWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION hideWidget Procedure 
FUNCTION hideWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Hides the object or objects in the FieldList.
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  
------------------------------------------------------------------------------*/
  
DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
DEFINE VARIABLE lInvalid  AS LOGICAL    NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF VALID-HANDLE(hField) THEN
      DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Use its DataModified property. */
          {set DisplayField NO hField}.
        ELSE IF CAN-SET(hField, "HIDDEN") THEN
              hField:HIDDEN = YES.
        ELSE lInvalid = YES.
      END.    /* END ELSE DO IF VALID-HANDLE */
      ELSE lInvalid = YES.
  END.        /* END DO iField */

  /* Return FALSE if any field was invalid. */
  RETURN NOT lInvalid.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-highlightWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION highlightWidget Procedure 
FUNCTION highlightWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER, INPUT pcHighlightType AS CHARACTER) :
/*------------------------------------------------------------------------------
  Purpose:  Changes the background color or equivalent for a field to
            highlight it in one way or another, or unhighlight it.
   Params:  INPUT pcFieldList AS CHARACTER, 
            INPUT pcHighlightType AS CHARACTER -- 
                "Warning" = yellow, 
                "Error" = red,
                "Reset" = reset to default.
    Notes:  
------------------------------------------------------------------------------*/
DEFINE VARIABLE hField      AS HANDLE     NO-UNDO.
DEFINE VARIABLE iField      AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField      AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hBuffer     AS HANDLE     NO-UNDO.
DEFINE VARIABLE lInvalid    AS LOGICAL    NO-UNDO INIT NO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).

      /* If there's a FILE-NAME, then this is a SmartDataField. 
         There's no standard highlight function for SDFs, so skip it. */
      IF NOT VALID-HANDLE(hField) OR CAN-QUERY(hField, "FILE-NAME") OR 
        NOT CAN-SET(hField,'BGCOLOR') THEN
          lInvalid = YES.
      ELSE hField:BGCOLOR = 
          IF      pcHighlightType = "Warning"    THEN 14
          ELSE IF pcHighlightType = "Error"      THEN 12
          ELSE ?.  /* Reset if it's "Reset" or any invalid value. */
  END.

  /* Return false if any invalid handle was found.  */
  RETURN NOT lInvalid.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setWidgetDelimiter) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setWidgetDelimiter Procedure 
FUNCTION setWidgetDelimiter RETURNS LOGICAL
  ( INPUT pcType AS CHARACTER, INPUT pcDelim AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Sets the delimiter between names in a list and/or values in
            a list from its default ("," for names, "|" for values), or back.
    Params: INPUT pcType AS CHARACTER ('Name', 'Value', 'Both)
            INPUT pcDelim AS CHARACTER (single-character string, 
                or "" or ? for reset)
    Notes:  
------------------------------------------------------------------------------*/
  
  IF pcDelim = ? THEN
      pcDelim = "".    /* Treat both these values as "reset" */

  IF NOT CAN-DO ("Name,Value,Both", pcType) OR LENGTH(pcDelim) > 1 THEN
      RETURN FALSE.   /* Input parameters were invalid. */

  IF pcType = "Name" OR pcType = "Both" THEN 
      gcFieldDelim = IF pcDelim = "" THEN "," ELSE pcDelim.
  IF pcType = "Value" OR pcType = "Both" THEN
      gcValueDelim = IF pcDelim = "" THEN "|" ELSE pcDelim.

  RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-viewWidget) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION viewWidget Procedure 
FUNCTION viewWidget RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Views the object or objects in the FieldList.
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  
------------------------------------------------------------------------------*/
  
DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
DEFINE VARIABLE lInvalid  AS LOGICAL    NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF VALID-HANDLE(hField) THEN
      DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Use its DataModified property. */
          {set DisplayField YES hField}.
        ELSE IF CAN-SET(hField, "HIDDEN") THEN
              hField:HIDDEN = NO.
        ELSE lInvalid = YES.
      END.    /* END ELSE DO IF VALID-HANDLE */
      ELSE lInvalid = YES.
  END.        /* END DO iField */

  /* Return FALSE if any field was invalid. */
  RETURN NOT lInvalid.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION widgetHandle Procedure 
FUNCTION widgetHandle RETURNS HANDLE
  ( pcWidget AS CHARACTER, phTarget AS HANDLE ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the widget handle of any object in the Target-Procedure
   Params:  INPUT pcWidget -- widget name
  Returns:  widget handle of the object
------------------------------------------------------------------------------*/

  DEFINE VARIABLE iFieldPos      AS INTEGER    NO-UNDO.
  DEFINE VARIABLE cQualifier     AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cWidget        AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cSelfName      AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cContainerType AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE hContainer     AS HANDLE     NO-UNDO.
  DEFINE VARIABLE cTargets       AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE iTarget        AS INTEGER    NO-UNDO.
  DEFINE VARIABLE hTarget        AS HANDLE     NO-UNDO.
  DEFINE VARIABLE cObjectName    AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE lDataObject    AS LOGICAL    NO-UNDO.
  DEFINE VARIABLE cType          AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cFieldNames    AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cFieldHandles  AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cObjectType    AS CHARACTER  NO-UNDO.

  {get ObjectType cObjectType phTarget}.
  /* First check for a qualifier if any and separate it from the widget name. */
  IF NUM-ENTRIES(pcWidget, ".") = 2 THEN
      ASSIGN cQualifier = ENTRY(1, pcWidget, ".")
             cWidget    = ENTRY(2, pcWidget, ".").
  ELSE ASSIGN cQualifier = ""
              cWidget = pcWidget.
 
  /* Next determine whether this is the container or an object inside a
     container. In either case build a list of all the objects in the 
     container.  */
  {get ContainerType cContainerType phTarget} NO-ERROR.
  IF cContainerType NE "WINDOW" THEN
      {get ContainerSource hContainer phTarget}.
  ELSE hContainer = TARGET-PROCEDURE.
  {get ContainerTarget cTargets hContainer}.

  IF cQualifier = "" OR cQualifier = "SELF" THEN
      hTarget = phTarget.    /* Search self first. */
  ELSE DO:
      /* Find out if the qualifier is the same as the SELF object. */
      {get LogicalObjectName cSelfName phTarget}.
      IF cSelfName = cQualifier THEN
          ASSIGN cQualifier = "SELF"  /* if so, just change it to SELF */
                 hTarget = phTarget.

      /* If there's a qualifier that isn't just 'SELF', we need to determine
         which objects are identified by the qualifier. */
      ELSE DO:
          DO iTarget = 1 TO NUM-ENTRIES(cTargets):
              hTarget = WIDGET-HANDLE(ENTRY(iTarget, cTargets)).
              {get LogicalObjectName cObjectName hTarget}.
              IF cObjectName = cQualifier THEN
              DO:
                  {get ObjectType cType hTarget}.
                  lDataObject = (cType = 'SmartDataObject').
                  LEAVE.  /* exit the DO iTarget block */
              END.     /* END DO IF the Object Name matches the Qualifier. */
              hTarget = ?. /* If we don't leave this must be unknown. */
          END.         /* END DO iTarget */
     
          /* Now we've identified the object that matched the Qualifier. If that's
             an SDO, then the target list is all its Data-Targets. Otherwise
             the target list is the one object name matching the qualifier. */
          IF lDataObject THEN
          DO:
              {get DataTarget cTargets hTarget}.
              hTarget = ?.  /* Signal that there isn't a single object to search. */
          END.   /* END DO IF Data Object */
          /* Otherwise there is the one object to search and it's not SELF. */
          ELSE IF VALID-HANDLE(hTarget) THEN 
              cTargets = STRING(hTarget).  
          ELSE cTargets = "".   /* Otherwise no matching object was found. */
      END.       /* END ELSE DO IF qualifier isn't SELF or the same as SELF. */
  END.           /* END IF cQualifier isn't blank or SELF */

  /* If the target handle is the TARGET-PROCEDURE then search it first. */
  IF hTarget = phTarget THEN
  DO:
      IF cObjectType = "SmartDataBrowser" THEN
      DO:
          {get DisplayedFields cFieldNames   hTarget}.
          {get FieldHandles    cFieldHandles hTarget}.
      END.
      ELSE DO:
          {get AllFieldNames   cFieldNames   hTarget}.
          {get AllFieldHandles cFieldHandles hTarget}.
      END.
      iFieldPos = LOOKUP(cWidget, cFieldNames).
      IF iFieldPos NE 0 THEN
          RETURN WIDGET-HANDLE(ENTRY(iFieldPos, cFieldHandles)).
  END.    /* END DO IF target = phtarget */

  /* If I got here then either the SELF object wasn't searched, or the widget
     wasn't found there. If there are more objects to search, do so. Otherwise
     return unknown. */
  IF cQualifier NE "SELF" THEN
    DO iTarget = 1 TO NUM-ENTRIES(cTargets):
      hTarget = WIDGET-HANDLE(ENTRY(iTarget, cTargets)).
      IF hTarget NE phTarget THEN
      DO:   /* Don't search TARGET-PROCEDURE over again. */
          {get ObjectType cObjectType hTarget}.
          IF cObjectType = "SmartDataBrowser" THEN
          DO:
              {get DisplayedFields cFieldNames   hTarget}.
              {get FieldHandles    cFieldHandles hTarget}.
          END.
          ELSE DO:
              {get AllFieldNames   cFieldNames   hTarget}.
              {get AllFieldHandles cFieldHandles hTarget}.
          END.
          iFieldPos = LOOKUP(cWidget, cFieldNames).
            IF iFieldPos NE 0 THEN
              RETURN WIDGET-HANDLE(ENTRY(iFieldPos, cFieldHandles)).
      END.  /* END DO IF target isn't phtarget */
    END.    /* END DO iTarget */
  
    /* If I got this far I didn't find it anywhere I was supposed to look. */
    RETURN ?.
        

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetModified) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION widgetModified Procedure 
FUNCTION widgetModified RETURNS LOGICAL
  ( INPUT pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns a logical value indicating whether the value of any of
            the list of fields passed in has changed since it was displayed.
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  A single LOGICAL value is returned if *any* of the INPUT fields
            has changed. This makes it easy to determine whether any of the
            values which are involved in an expression or calculation have 
            changed.
            The function returns unknown (?) if any field is invalid or
            can't be queried.
------------------------------------------------------------------------------*/
  
DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
DEFINE VARIABLE lModified AS LOGICAL    NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF NOT VALID-HANDLE(hField) THEN
          RETURN ?.
      ELSE DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Use its DataModified property. */
          {get DataModified lModified hField}.
        ELSE IF CAN-QUERY(hField, "MODIFIED") THEN
              lModified = hField:MODIFIED.
        ELSE RETURN ?.

        IF lModified THEN
            RETURN TRUE.
      END.    /* END ELSE DO IF VALID-HANDLE */
  END.        /* END DO iField */

  /* If we fell through, then no field was modified. */
  RETURN FALSE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-widgetValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION widgetValue Procedure 
FUNCTION widgetValue RETURNS CHARACTER
  ( pcFieldList AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the value of a field or fields on the screen
   Params:  INPUT pcFieldList AS CHARACTER
    Notes:  
------------------------------------------------------------------------------*/

DEFINE VARIABLE hField      AS HANDLE     NO-UNDO.
DEFINE VARIABLE iField      AS INTEGER    NO-UNDO.
DEFINE VARIABLE cField      AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cValue      AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cValueList  AS CHARACTER  NO-UNDO INIT "".
DEFINE VARIABLE hBuffer     AS HANDLE     NO-UNDO.

  DO iField = 1 TO NUM-ENTRIES(pcFieldList, gcFieldDelim):
      cField = ENTRY(iField, pcFieldList, gcFieldDelim).
      hField = widgetHandle(cField, TARGET-PROCEDURE).
      IF NOT VALID-HANDLE(hField) THEN
          cValue = "?".
      ELSE DO:
        IF CAN-QUERY(hField, "FILE-NAME") THEN
          /* This is a SmartDataField. Return its DataValue property.
             Note that this is the underlying "key" value that is meaningful
             to the code, not the "DisplayValue" shown to the user. */
          {get DataValue cValue hField}.
        ELSE IF CAN-QUERY(hField, "SCREEN-VALUE") THEN
              cValue = hField:SCREEN-VALUE.
        ELSE DO: 
            {get QueryRowObject hBuffer} NO-ERROR.
            IF NUM-ENTRIES(cField, ".") = 2 THEN
                cField = ENTRY(2, cField, ".").
            IF VALID-HANDLE(hBuffer) THEN
                ASSIGN hField = hBuffer:BUFFER-FIELD(cField)
                       cValue = STRING(hField:BUFFER-VALUE) NO-ERROR.
        END.  /* END ELSE DO IF NOT CAN-READ SCREEN-VALUE (Browse) */
      END.    /* END ELSE DO IF VALID-HANDLE */
      IF cValue = ? THEN
         cValue = "?".
      cValueList = cValueList + (IF cValueList = "" THEN "" ELSE gcValueDelim) +
          cValue.
  END.

  /* If one field is requested and it's not there return the unknown value.
     Otherwise return a literal question mark for any field not found. */
  RETURN IF cValueList = "?" THEN ? ELSE cValueList.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

