/* h-BinCheck.p */

DEFINE INPUT  PARAMETER pcItemList      AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER pcWarehouseList AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER pcBestWarehouse AS CHARACTER  NO-UNDO.

DEFINE VARIABLE iEntry    AS INTEGER    NO-UNDO.
DEFINE VARIABLE iItemNum  AS INTEGER    NO-UNDO.
DEFINE VARIABLE iWHQty    AS INTEGER    NO-UNDO.
DEFINE VARIABLE iWHNum    AS INTEGER    NO-UNDO.
DEFINE VARIABLE iBestWH   AS INTEGER    NO-UNDO.
DEFINE VARIABLE cBestList AS CHARACTER  NO-UNDO.

FOR EACH Warehouse:
  cBestList = cBestList + "0,".
END.
cBestList = RIGHT-TRIM(cBestList, ",").

DO iEntry = 1 TO NUM-ENTRIES(pcItemList):
  iItemNum = INTEGER(ENTRY(iEntry, pcItemList)).
  FOR EACH Bin NO-LOCK WHERE Bin.ItemNum = iItemNum:
    IF Bin.Qty = 0 THEN DO:
      FIND Warehouse NO-LOCK
        WHERE Warehouse.WarehouseNum = Bin.WarehouseNum.
      IF LOOKUP(WarehouseName, pcWarehouseList) = 0 THEN
        pcWarehouseList = pcWarehouseList +
         (IF pcWarehouseList = "" THEN "" ELSE ",") + 
         Warehouse.WarehouseName.
    END.
  END.

  ASSIGN 
    iWHQty = 0 
    iWHNum = 0.
      
  REPEAT PRESELECT EACH Bin NO-LOCK WHERE Bin.ItemNum = iItemNum,
    FIRST Warehouse NO-LOCK
      WHERE Warehouse.WarehouseNum = Bin.WarehouseNum AND 
        Warehouse.Country = "USA" BY Bin.Qty DESCENDING:
      
    FIND NEXT Warehouse NO-LOCK.
    IF iWHQty NE 0 AND iWHQty - Bin.Qty > 100 THEN
      ASSIGN 
        iBestWH = INTEGER(ENTRY(iWHNum, cBestList))
        iBestWH = iBestWH + 1
        ENTRY(iWHNum, cBestList) = STRING(iBestWH).           
    ELSE IF iWHQty NE 0 THEN LEAVE.
    ASSIGN 
      iWHQty = Bin.Qty
      iWHNum = Warehouse.WarehouseNum.
  END. /* REPEAT PRESELECT EACH Bin... */
END. /* DO iEntry... */

DO iEntry = 1 TO NUM-ENTRIES(cBestList):
  IF INTEGER(ENTRY(iEntry, cBestList)) >= (NUM-ENTRIES(pcItemList) - 1) THEN DO:
    FIND Warehouse NO-LOCK WHERE Warehouse.WarehouseNum = iEntry.
    pcBestWarehouse = Warehouse.WarehouseName.
    LEAVE.
  END.
END.
