&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS CustWin 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE iQueryRow  AS INTEGER    NO-UNDO.

{h-ttOline.i}
/* DEFINE TEMP-TABLE ttOline LIKE Orderline
    FIELD ItemName LIKE ITEM.ItemName
    FIELD TotalWeight AS DECIMAL LABEL "Tot.Wgt." .  */

DEFINE QUERY OlineQuery FOR ttOline.


DEFINE BROWSE OlineBrowse
  QUERY OlineQuery NO-LOCK DISPLAY
      ttOline.Ordernum 
      ttOline.LineNum LABEL "Line"
      ttOline.ItemNum LABEL "Item" FORMAT "ZZZ9"
      ttOline.ItemName FORMAT "x(20)"
      ttOline.TotalWeight
      ttOline.Price FORMAT "ZZ,ZZ9.99"
      ttOline.Qty
      ttOline.Discount
      ttOline.ExtendedPrice LABEL "Ext.Price" FORMAT "ZZZ,ZZ9.99"
    WITH NO-ROW-MARKERS SEPARATORS 7 DOWN ROW-HEIGHT-CHARS .57.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME CustQuery
&Scoped-define BROWSE-NAME OrderBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Customer Order

/* Definitions for BROWSE OrderBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OrderBrowse Order.Ordernum Order.OrderDate ~
Order.PromiseDate Order.ShipDate Order.PO 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OrderBrowse 
&Scoped-define QUERY-STRING-OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OrderBrowse OPEN QUERY OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OrderBrowse Order
&Scoped-define FIRST-TABLE-IN-QUERY-OrderBrowse Order


/* Definitions for FRAME CustQuery                                      */
&Scoped-define FIELDS-IN-QUERY-CustQuery Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-FIELDS-IN-QUERY-CustQuery Customer.CustNum ~
Customer.Name Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-CustQuery Customer
&Scoped-define OPEN-BROWSERS-IN-QUERY-CustQuery ~
    ~{&OPEN-QUERY-OrderBrowse}
&Scoped-define QUERY-STRING-CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City
&Scoped-define OPEN-QUERY-CustQuery OPEN QUERY CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City.
&Scoped-define TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-TABLE-IN-QUERY-CustQuery Customer


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES Customer
&Scoped-define FIRST-ENABLED-TABLE Customer
&Scoped-Define ENABLED-OBJECTS BtnFirst BtnNext BtnPrev BtnLast PosButton ~
ReposButton cState OrderBrowse 
&Scoped-Define DISPLAYED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define DISPLAYED-TABLES Customer
&Scoped-define FIRST-DISPLAYED-TABLE Customer
&Scoped-Define DISPLAYED-OBJECTS cState iMatches 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR CustWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BtnFirst 
     LABEL "First" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnLast 
     LABEL "Last" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnNext 
     LABEL "Next" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnPrev 
     LABEL "Prev" 
     SIZE 15 BY 1.14.

DEFINE BUTTON PosButton 
     LABEL "Save Position" 
     SIZE 17 BY 1.14.

DEFINE BUTTON ReposButton 
     LABEL "Restore Position" 
     SIZE 18 BY 1.14.

DEFINE VARIABLE cState AS CHARACTER FORMAT "X(256)":U 
     LABEL "New State" 
     VIEW-AS FILL-IN 
     SIZE 15 BY 1 NO-UNDO.

DEFINE VARIABLE iMatches AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 
     LABEL "Number of Matches" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OrderBrowse FOR 
      Order SCROLLING.

DEFINE QUERY CustQuery FOR 
      Customer SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OrderBrowse CustWin _STRUCTURED
  QUERY OrderBrowse NO-LOCK DISPLAY
      Order.Ordernum FORMAT "zzzzzzzzz9":U
      Order.OrderDate FORMAT "99/99/99":U
      Order.PromiseDate FORMAT "99/99/99":U
      Order.ShipDate FORMAT "99/99/9999":U
      Order.PO FORMAT "x(20)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 65 BY 6.19 ROW-HEIGHT-CHARS .57 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME CustQuery
     BtnFirst AT ROW 1.48 COL 8
     BtnNext AT ROW 1.48 COL 24.6
     BtnPrev AT ROW 1.48 COL 41.2
     BtnLast AT ROW 1.48 COL 58
     PosButton AT ROW 1.48 COL 79
     ReposButton AT ROW 1.48 COL 102
     Customer.CustNum AT ROW 3.38 COL 13.4 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     Customer.Name AT ROW 3.38 COL 37 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 32 BY 1
     cState AT ROW 3.38 COL 100 COLON-ALIGNED
     Customer.Address AT ROW 4.57 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 37 BY 1
     iMatches AT ROW 4.81 COL 100 COLON-ALIGNED
     Customer.City AT ROW 5.76 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 27 BY 1
     Customer.State AT ROW 5.76 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     OrderBrowse AT ROW 7.67 COL 13
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 175.2 BY 13.91.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW CustWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Customers and Orders"
         HEIGHT             = 13.91
         WIDTH              = 175.2
         MAX-HEIGHT         = 22.43
         MAX-WIDTH          = 185.4
         VIRTUAL-HEIGHT     = 22.43
         VIRTUAL-WIDTH      = 185.4
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW CustWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME CustQuery
                                                                        */
/* BROWSE-TAB OrderBrowse State CustQuery */
/* SETTINGS FOR FILL-IN iMatches IN FRAME CustQuery
   NO-ENABLE                                                            */
ASSIGN 
       iMatches:READ-ONLY IN FRAME CustQuery        = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
THEN CustWin:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME CustQuery
/* Query rebuild information for FRAME CustQuery
     _TblList          = "Sports2000.Customer"
     _OrdList          = "Sports2000.Customer.City|yes"
     _Where[1]         = "Customer.State = ""NH"""
     _Query            is OPENED
*/  /* FRAME CustQuery */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OrderBrowse
/* Query rebuild information for BROWSE OrderBrowse
     _TblList          = "sports2000.Order OF sports2000.Customer"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = sports2000.Order.Ordernum
     _FldNameList[2]   = sports2000.Order.OrderDate
     _FldNameList[3]   = sports2000.Order.PromiseDate
     _FldNameList[4]   = sports2000.Order.ShipDate
     _FldNameList[5]   = sports2000.Order.PO
     _Query            is OPENED
*/  /* BROWSE OrderBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON END-ERROR OF CustWin /* Customers and Orders */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON WINDOW-CLOSE OF CustWin /* Customers and Orders */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnFirst
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnFirst CustWin
ON CHOOSE OF BtnFirst IN FRAME CustQuery /* First */
DO:
  {h-ButtonTrig1.i FIRST}
  /* GET FIRST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnLast
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnLast CustWin
ON CHOOSE OF BtnLast IN FRAME CustQuery /* Last */
DO:
    {h-ButtonTrig1.i LAST}
  /* GET LAST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnNext
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnNext CustWin
ON CHOOSE OF BtnNext IN FRAME CustQuery /* Next */
DO:
    {h-ButtonTrig1.i NEXT}
  /* GET NEXT CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnPrev
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnPrev CustWin
ON CHOOSE OF BtnPrev IN FRAME CustQuery /* Prev */
DO:
    {h-ButtonTrig1.i PREV}
  /* GET PREV CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cState
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cState CustWin
ON LEAVE OF cState IN FRAME CustQuery /* New State */
DO:
  cState = Customer.State.
  OPEN QUERY CustQuery FOR EACH Customer WHERE Customer.State = 
      cState:SCREEN-VALUE BY Customer.City.
      /* Check whether the State was valid or not. */
  iMatches = NUM-RESULTS("CustQuery").
  IF iMatches = 0 THEN
  DO:
      MESSAGE "There are no Customers that match the State" 
          cState:SCREEN-VALUE "." SKIP
          "Restoring the previous State."
          VIEW-AS ALERT-BOX WARNING.
      /* Reopen the query with the previous state. */
      OPEN QUERY CustQuery FOR EACH Customer WHERE Customer.State = 
      cState BY Customer.City.
      /* Display the previous valid state as well. */
      DISPLAY cState WITH FRAME CustQuery.
  END.
  ELSE DISPLAY iMatches WITH FRAME CustQuery.
  
  APPLY "CHOOSE" TO BtnFirst.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OrderBrowse
&Scoped-define SELF-NAME OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON VALUE-CHANGED OF OrderBrowse IN FRAME CustQuery
DO:
  RUN h-fetchOlines.p (INPUT Order.OrderNum, OUTPUT TABLE ttOline).
  OPEN QUERY OlineQuery FOR EACH ttOline.
  DISPLAY OlineBrowse WITH FRAME CustQuery.
  ENABLE OlineBrowse WITH FRAME CustQuery.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME PosButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL PosButton CustWin
ON CHOOSE OF PosButton IN FRAME CustQuery /* Save Position */
DO:
  iQueryRow = CURRENT-RESULT-ROW('CustQuery').
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME ReposButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ReposButton CustWin
ON CHOOSE OF ReposButton IN FRAME CustQuery /* Restore Position */
DO:
  REPOSITION CustQuery TO ROW iQueryRow.
  APPLY "CHOOSE" TO BtnNext.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK CustWin 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  ASSIGN cState = Customer.State
         iMatches = NUM-RESULTS("CustQuery").
  DISPLAY cState iMatches WITH FRAME CustQuery.
  APPLY "VALUE-CHANGED" TO OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI CustWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
  THEN DELETE WIDGET CustWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI CustWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-CustQuery}
  GET FIRST CustQuery.
  DISPLAY cState iMatches 
      WITH FRAME CustQuery IN WINDOW CustWin.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  ENABLE BtnFirst BtnNext BtnPrev BtnLast PosButton ReposButton 
         Customer.CustNum Customer.Name cState Customer.Address Customer.City 
         Customer.State OrderBrowse 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  VIEW CustWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

