&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : 
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

DEFINE TEMP-TABLE ttCust LIKE Customer.
DEFINE TEMP-TABLE ttOrder NO-UNDO LIKE Order FIELD TransType AS CHARACTER
    INDEX OrderIdx OrderNum TransType.
DEFINE TEMP-TABLE ttOline NO-UNDO LIKE OrderLine FIELD TransType AS CHARACTER
    INDEX OlineIdx OrderNum LineNum TransType.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 6.38
         WIDTH              = 60.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-fetchOrder) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fetchOrder Procedure 
PROCEDURE fetchOrder :
/*------------------------------------------------------------------------------
  Procedure fetchOrder:
  Purpose:     Return an Order, its Customer, and all its related OrderLines
               to the caller.
         
------------------------------------------------------------------------------*/
DEFINE INPUT  PARAMETER piOrderNum AS INTEGER    NO-UNDO.
DEFINE OUTPUT PARAMETER TABLE FOR ttOrder.
DEFINE OUTPUT PARAMETER TABLE FOR ttCust.
DEFINE OUTPUT PARAMETER TABLE FOR ttOline.

FIND Order WHERE Order.OrderNum = piOrderNum NO-LOCK  NO-ERROR.
IF NOT AVAILABLE(Order) THEN
    RETURN "Order not found".

EMPTY TEMP-TABLE ttOrder.
CREATE ttOrder.
BUFFER-COPY Order TO ttOrder.

FIND Customer OF Order.
EMPTY TEMP-TABLE ttCust.
CREATE ttCust.
BUFFER-COPY Customer TO ttCust.

EMPTY TEMP-TABLE ttOline.
FOR EACH OrderLine OF Order:
    CREATE ttOline.
    BUFFER-COPY OrderLine TO ttOline.
END.

RETURN "".
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-saveOrder) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE saveOrder Procedure 
PROCEDURE saveOrder :
/*------------------------------------------------------------------------------
  Procedure saveOrder:
  Purpose:     Accepts updates to an Order and its related records and
               saves them to the database, returning any field values calculated
               during the update process. 
------------------------------------------------------------------------------*/
DEFINE INPUT-OUTPUT  PARAMETER TABLE FOR ttOrder.
DEFINE INPUT-OUTPUT  PARAMETER TABLE FOR ttOline.

DEFINE BUFFER bUpdateOrder FOR ttOrder.
DEFINE BUFFER bUpdateOline FOR ttOline.
DEFINE BUFFER Order FOR Order.
DEFINE BUFFER OrderLine FOR OrderLine.

DEFINE VARIABLE cCompare AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cMessage AS CHARACTER  NO-UNDO.

  TransBlock:
  DO TRANSACTION ON ERROR UNDO, LEAVE:
    FIND ttOrder WHERE ttOrder.TransType = "" NO-ERROR.
    IF AVAILABLE (ttOrder) THEN
        /* If this rec is there then the Order was updated on the client. */
    DO:
        FIND Order WHERE Order.OrderNum = ttOrder.OrderNum EXCLUSIVE-LOCK.
        BUFFER-COMPARE ttOrder TO Order SAVE cCompare.
        IF cCompare NE "" THEN
        DO:   /* Somebody else has changed the record since we read it. */
            BUFFER-COPY Order TO ttOrder.   /* Return the changes. */
            RETURN "Changed Order".
        END.   /* END DO IF cCompare Not "" */
        ELSE DO:  /* FIND the updated tt rec and save the changes. */
            FIND bUpdateOrder WHERE bUpdateOrder.TransType = "U".
            BUFFER-COPY bUpdateOrder TO Order.  /* Save our changes. */
        END.   /* END ELSE DO */
    END.       /* END OF AVAILABLE ttOrder */
  

    /* For each OrderLine that has a before-image (unchanged) record,
       make sure it hasn't been changed by another user. */
    FOR EACH ttOline WHERE ttOline.TransType = "":
        /* Bring the updated version into the other buffer. */
        FIND bUpdateOline WHERE bUpdateOline.TransType = "U" AND
                bUpdateOline.OrderNum = ttOline.OrderNum AND
                bUpdateOline.LineNum = ttOline.LineNum.
        FIND OrderLine WHERE OrderLine.OrderNum = ttOline.OrderNum AND
            OrderLine.LineNum = ttOline.LineNum EXCLUSIVE-LOCK.
        BUFFER-COMPARE ttOline TO OrderLine SAVE cCompare.
        IF cCompare NE "" THEN
        DO:   /* Somebody else has changed the record since we read it. 
                 Copy the changes to the Update version to display on the client. */
            BUFFER-COPY OrderLine TO bUpdateOline.   /* Return the changes. */
            RETURN "Changed Oline".
        END.   /* END DO IF cCompare NE "" */
        ELSE DO:
            BUFFER-COPY bUpdateOline TO OrderLine. /* Save our OrderLine changes. */
            RELEASE OrderLine.
            /* Re-find the db record to capture any changes made by a trigger. */
            FIND OrderLine WHERE OrderLine.OrderNum = bUpdateOline.OrderNum AND
                OrderLine.LineNum = bUpdateOline.LineNum NO-LOCK.
            BUFFER-COPY OrderLine TO bUpdateOline.
            IF bUpdateOline.ExtendedPrice > (ttOline.ExtendedPrice * 1.2) THEN
            DO:
                cMessage = cMessage + 
                           "Line " + STRING(OrderLine.LineNum) + 
                           ": Can't increase price by more than 20%." + CHR(10).
                UNDO, NEXT.
            END. 
        END.   /* END ELSE DO If we updated the OrderLine */
    END.       /* END DO FOR EACH ttOline */
  END.         /* END DO Transaction */

    IF cMessage NE "" THEN 
    DO: 
        FOR EACH OrderLine WHERE OrderLine.OrderNum = bUpdateOline.OrderNum NO-LOCK:
            FIND bUpdateOline WHERE OrderLine.LineNum = bUpdateOline.LineNum
                AND bUpdateOline.TransType = "U".
            BUFFER-COPY OrderLine TO bUpdateOline.
        END.
        RETURN cMessage.
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

