&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME C-Win

/* Temp-Table and Buffer definitions                                    */
DEFINE TEMP-TABLE ttCust NO-UNDO LIKE Customer.
DEFINE TEMP-TABLE ttOline NO-UNDO LIKE OrderLine
       FIELD TransType AS CHARACTER
       INDEX OlineIdx OrderNum LineNum TransType.
DEFINE TEMP-TABLE ttOrder NO-UNDO LIKE Order
       FIELD TransType AS CHARACTER
       INDEX OrderIdx OrderNum TransType
       .


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE hLogic AS HANDLE     NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME OrderFrame
&Scoped-define BROWSE-NAME OlineBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES ttOline ttOrder ttCust

/* Definitions for BROWSE OlineBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OlineBrowse ttOline.Ordernum ttOline.Linenum ~
ttOline.Itemnum ttOline.Price ttOline.Qty ttOline.ExtendedPrice ~
ttOline.Discount ttOline.OrderLineStatus 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OlineBrowse ttOline.Itemnum ~
ttOline.Price ttOline.Qty ttOline.Discount ttOline.OrderLineStatus 
&Scoped-define ENABLED-TABLES-IN-QUERY-OlineBrowse ttOline
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-OlineBrowse ttOline
&Scoped-define QUERY-STRING-OlineBrowse FOR EACH ttOline NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OlineBrowse OPEN QUERY OlineBrowse FOR EACH ttOline NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OlineBrowse ttOline
&Scoped-define FIRST-TABLE-IN-QUERY-OlineBrowse ttOline


/* Definitions for FRAME OrderFrame                                     */
&Scoped-define FIELDS-IN-QUERY-OrderFrame ttOrder.Ordernum ~
ttOrder.OrderDate ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ~
ttOrder.OrderStatus ttCust.CustNum ttCust.Name ttCust.City ttCust.State ~
ttCust.CreditLimit ttCust.Balance 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OrderFrame ttOrder.Ordernum ~
ttOrder.OrderDate ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ~
ttOrder.OrderStatus 
&Scoped-define ENABLED-TABLES-IN-QUERY-OrderFrame ttOrder
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-OrderFrame ttOrder
&Scoped-define OPEN-BROWSERS-IN-QUERY-OrderFrame ~
    ~{&OPEN-QUERY-OlineBrowse}
&Scoped-define QUERY-STRING-OrderFrame FOR EACH ttOrder SHARE-LOCK, ~
      EACH ttCust WHERE TRUE /* Join to ttOrder incomplete */ SHARE-LOCK
&Scoped-define OPEN-QUERY-OrderFrame OPEN QUERY OrderFrame FOR EACH ttOrder SHARE-LOCK, ~
      EACH ttCust WHERE TRUE /* Join to ttOrder incomplete */ SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-OrderFrame ttOrder ttCust
&Scoped-define FIRST-TABLE-IN-QUERY-OrderFrame ttOrder
&Scoped-define SECOND-TABLE-IN-QUERY-OrderFrame ttCust


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS ttOrder.Ordernum ttOrder.OrderDate ~
ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus 
&Scoped-define ENABLED-TABLES ttOrder
&Scoped-define FIRST-ENABLED-TABLE ttOrder
&Scoped-Define ENABLED-OBJECTS btnFetch btnSave OlineBrowse RECT-2 
&Scoped-Define DISPLAYED-FIELDS ttOrder.Ordernum ttOrder.OrderDate ~
ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus ~
ttCust.CustNum ttCust.Name ttCust.City ttCust.State ttCust.CreditLimit ~
ttCust.Balance 
&Scoped-define DISPLAYED-TABLES ttOrder ttCust
&Scoped-define FIRST-DISPLAYED-TABLE ttOrder
&Scoped-define SECOND-DISPLAYED-TABLE ttCust


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnFetch 
     LABEL "Fetch" 
     SIZE 8 BY 1.14.

DEFINE BUTTON btnSave 
     LABEL "Save" 
     SIZE 7 BY 1.14.

DEFINE RECTANGLE RECT-2
     EDGE-PIXELS 2 GRAPHIC-EDGE  
     SIZE 75 BY .48
     BGCOLOR 4 FGCOLOR 4 .

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OlineBrowse FOR 
      ttOline SCROLLING.

DEFINE QUERY OrderFrame FOR 
      ttOrder, 
      ttCust SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE OlineBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OlineBrowse C-Win _STRUCTURED
  QUERY OlineBrowse NO-LOCK DISPLAY
      ttOline.Ordernum FORMAT "zzzzzzzzz9":U
      ttOline.Linenum FORMAT ">>9":U
      ttOline.Itemnum FORMAT "zzzzzzzzz9":U
      ttOline.Price FORMAT "->,>>>,>>9.99":U
      ttOline.Qty FORMAT "->>>>9":U
      ttOline.ExtendedPrice FORMAT "->>>,>>9.99":U
      ttOline.Discount FORMAT ">>9%":U
      ttOline.OrderLineStatus FORMAT "x(20)":U
  ENABLE
      ttOline.Itemnum
      ttOline.Price
      ttOline.Qty
      ttOline.Discount
      ttOline.OrderLineStatus
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 80 BY 8.1 EXPANDABLE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME OrderFrame
     ttOrder.Ordernum AT ROW 1.24 COL 12 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     btnFetch AT ROW 1.24 COL 30
     btnSave AT ROW 1.24 COL 39
     ttOrder.OrderDate AT ROW 1.24 COL 56 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     ttOrder.PromiseDate AT ROW 2.43 COL 12 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     ttOrder.ShipDate AT ROW 2.43 COL 56 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     ttOrder.PO AT ROW 3.62 COL 12 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     ttOrder.OrderStatus AT ROW 3.62 COL 56 COLON-ALIGNED
          VIEW-AS COMBO-BOX 
          LIST-ITEMS "Ordered","Back Ordered","Partially Shipped","Shipped" 
          DROP-DOWN-LIST
          SIZE 20 BY 1
     ttCust.CustNum AT ROW 6 COL 11 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     ttCust.Name AT ROW 6 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 32 BY 1
     ttCust.City AT ROW 7.19 COL 11 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 27 BY 1
     ttCust.State AT ROW 7.19 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     ttCust.CreditLimit AT ROW 8.38 COL 11 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     ttCust.Balance AT ROW 8.38 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 20.2 BY 1
     OlineBrowse AT ROW 10.29 COL 1
     RECT-2 AT ROW 5.05 COL 5
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80.2 BY 17.38.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
   Temp-Tables and Buffers:
      TABLE: ttCust T "?" NO-UNDO sports2000 Customer
      TABLE: ttOline T "?" NO-UNDO sports2000 OrderLine
      ADDITIONAL-FIELDS:
          FIELD TransType AS CHARACTER
          INDEX OlineIdx OrderNum LineNum TransType
      END-FIELDS.
      TABLE: ttOrder T "?" NO-UNDO sports2000 Order
      ADDITIONAL-FIELDS:
          FIELD TransType AS CHARACTER
          INDEX OrderIdx OrderNum TransType
          
      END-FIELDS.
   END-TABLES.
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Order Updates"
         HEIGHT             = 17.38
         WIDTH              = 80.2
         MAX-HEIGHT         = 34.33
         MAX-WIDTH          = 204.8
         VIRTUAL-HEIGHT     = 34.33
         VIRTUAL-WIDTH      = 204.8
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME OrderFrame
                                                                        */
/* BROWSE-TAB OlineBrowse Balance OrderFrame */
/* SETTINGS FOR FILL-IN ttCust.Balance IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN ttCust.City IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN ttCust.CreditLimit IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN ttCust.CustNum IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN ttCust.Name IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN ttCust.State IN FRAME OrderFrame
   NO-ENABLE                                                            */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OlineBrowse
/* Query rebuild information for BROWSE OlineBrowse
     _TblList          = "Temp-Tables.ttOline"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = Temp-Tables.ttOline.Ordernum
     _FldNameList[2]   = Temp-Tables.ttOline.Linenum
     _FldNameList[3]   > Temp-Tables.ttOline.Itemnum
"ttOline.Itemnum" ? ? "integer" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[4]   > Temp-Tables.ttOline.Price
"ttOline.Price" ? ? "decimal" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[5]   > Temp-Tables.ttOline.Qty
"ttOline.Qty" ? ? "integer" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[6]   = Temp-Tables.ttOline.ExtendedPrice
     _FldNameList[7]   > Temp-Tables.ttOline.Discount
"ttOline.Discount" ? ? "integer" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[8]   > Temp-Tables.ttOline.OrderLineStatus
"ttOline.OrderLineStatus" ? ? "character" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _Query            is OPENED
*/  /* BROWSE OlineBrowse */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME OrderFrame
/* Query rebuild information for FRAME OrderFrame
     _TblList          = "Temp-Tables.ttOrder,Temp-Tables.ttCust WHERE Temp-Tables.ttOrder ..."
     _Query            is OPENED
*/  /* FRAME OrderFrame */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Order Updates */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Order Updates */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnFetch
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnFetch C-Win
ON CHOOSE OF btnFetch IN FRAME OrderFrame /* Fetch */
DO:
  DEFINE BUFFER bUpdateOline FOR ttOline.

    /* Remove any data leftover from previous calls. */
    EMPTY TEMP-TABLE ttCust.
    EMPTY TEMP-TABLE ttOrder.
    EMPTY TEMP-TABLE ttOline.
    /* Retrieve all related records for the Order. */
    RUN fetchOrder IN hLogic
      (INPUT INTEGER(ttOrder.OrderNum:SCREEN-VALUE),
       OUTPUT TABLE  ttOrder,
       OUTPUT TABLE  ttCust,
       OUTPUT TABLE  ttOline) .
    /* Check for an error such as order-not-found. */
    IF RETURN-VALUE NE "" THEN
    DO:
      MESSAGE RETURN-VALUE.
      RETURN NO-APPLY.
    END.
    /* Position to the one record for the Order and its Customer and
       display their fields. */
    FIND ttOrder.
    FIND ttCust.
    DISPLAY ttOrder.OrderNum ttOrder.OrderDate ttOrder.PromiseDate 
          ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus
          ttCust.CustNum ttCust.NAME ttCust.City ttCust.State
          ttCust.CreditLimit ttCust.Balance
      WITH FRAME OrderFrame.
    /* For each OrderLine, create a record to hold any updates. */
    FOR EACH ttOline WHERE ttOline.TransType = "":
        CREATE bUpdateOline.
        BUFFER-COPY ttOline TO bUpdateOline ASSIGN TransType = "U".
    END.
    /* Display just the updatable records in the browse. */
    OPEN QUERY OlineBrowse FOR EACH ttOline WHERE ttOline.TransType = "U".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnSave
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnSave C-Win
ON CHOOSE OF btnSave IN FRAME OrderFrame /* Save */
DO:
  DEFINE BUFFER bOldOrder FOR ttOrder.
  DEFINE BUFFER bOldOline FOR ttOline.

  DEFINE VARIABLE cCompare AS CHARACTER  NO-UNDO.

  /* Create an Update record in the Order temp-table for any changes. */
  FIND bOldOrder.
  CREATE ttOrder.
  BUFFER-COPY bOldOrder TO ttOrder.
  ASSIGN ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus
         ttOrder.TransType = "U".
  /* Check to see if anything was changed, and if not, then delete the
     before image record. */
  BUFFER-COMPARE ttOrder EXCEPT TransType TO bOldOrder SAVE cCompare.
  IF cCompare = "" THEN
      DELETE bOldOrder.

  /* For every OrderLine, compare the original and Update records to see
     if anything was in fact changed; if not, delete the original before saving. */
  FOR EACH bOldOline WHERE bOldOline.TransType = "U":
      FIND ttOline WHERE ttOline.OrderNum = bOldOline.OrderNum AND
          ttOline.LineNum = bOldOline.LineNum AND ttOline.TransType = "".
      BUFFER-COMPARE bOldOline EXCEPT TransType TO ttOline SAVE cCompare.
      IF cCompare = "" THEN     /* If there were no changes, */
           DELETE ttOline.      /*  delete the unchanged version of the rec. */
  END.

  RUN saveOrder IN hLogic
      (INPUT-OUTPUT TABLE ttOrder,
       INPUT-OUTPUT TABLE ttOLine).

  IF RETURN-VALUE = "Changed Order" THEN
  DO:
      MESSAGE "The Order has been changed by another user.".
      FIND ttOrder WHERE ttOrder.TransType = "".
      DISPLAY ttOrder.OrderDate ttOrder.PromiseDate ttOrder.Shipdate
              ttOrder.PO ttOrder.OrderStatus WITH FRAME OrderFrame.
      RETURN NO-APPLY.
  END.
  ELSE IF RETURN-VALUE = "Changed Oline" THEN
      MESSAGE "One or more OrderLines have been changed by another user.".
  ELSE IF RETURN-VALUE NE "" THEN
      MESSAGE RETURN-VALUE.
  
  OPEN QUERY OlineBrowse FOR EACH ttOline WHERE ttOline.TransType = "U".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OlineBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN h-OrderLogic.p PERSISTENT SET hLogic.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-OrderFrame}
  GET FIRST OrderFrame.
  IF AVAILABLE ttCust THEN 
    DISPLAY ttCust.CustNum ttCust.Name ttCust.City ttCust.State ttCust.CreditLimit 
          ttCust.Balance 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  IF AVAILABLE ttOrder THEN 
    DISPLAY ttOrder.Ordernum ttOrder.OrderDate ttOrder.PromiseDate 
          ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  ENABLE ttOrder.Ordernum btnFetch btnSave ttOrder.OrderDate 
         ttOrder.PromiseDate ttOrder.ShipDate ttOrder.PO ttOrder.OrderStatus 
         OlineBrowse RECT-2 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-OrderFrame}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

