{lt-10-in.i} /* Common Interface Setup Code */   

/**********  DEFINE TRIGGERS  **********/
ON CHOOSE of b-rep DO:  
  OUTPUT TO "tut-temp.txt".
  FOR EACH Customer FIELDS(Balance Contact CreditLimit CustNum Name) NO-LOCK
    WHERE Customer.Balance >= (Customer.CreditLimit * .85) WITH STREAM-IO:
    DISPLAY 
      Customer.Name FORMAT "x(20)" 
      Customer.Contact FORMAT "x(15)" 
      Customer.Balance 
      Customer.CreditLimit WITH NO-BOX.
            
    FOR EACH Order FIELDS(CustNum OrderNum OrderDate ShipDate PromiseDate) 
      NO-LOCK WHERE Order.CustNum = Customer.CustNum WITH STREAM-IO:
      DISPLAY Order.OrderNum Order.OrderDate Order.ShipDate Order.PromiseDate 
        SKIP(1) WITH 2 COLUMNS.
    END.
  END.    
  OUTPUT CLOSE.
    
  ASSIGN 
    Rep-Editor:READ-ONLY IN FRAME Dialog1 = TRUE
    Rep-Editor:SENSITIVE IN FRAME Dialog1 = TRUE
    FRAME Dialog1:TITLE                   = "Report Output"
    lStat = Rep-Editor:READ-FILE("tut-temp.txt") IN FRAME Dialog1. 
             
  IF lStat THEN DO:
    ENABLE Rep-Editor b-ok WITH FRAME Dialog1.
    WAIT-FOR GO OF FRAME Dialog1.
    HIDE FRAME Dialog1.
  END.
END.

/**********  MAIN LOGIC  **********/
ENABLE ALL WITH FRAME Frame1.
WAIT-FOR CHOOSE OF b-exit.
