/* pi-write-json-pds2.i */
/* Definition of a ProDataSet. These temp-tables have only 1 foreign key
   between each pair to avoid problems when inferring schema with the 
   READ-JSON() method from this PDS. */

DEFINE TEMP-TABLE ttCustomer NO-UNDO LIKE Customer.
DEFINE TEMP-TABLE ttOrder    NO-UNDO 
  FIELD OrderNum    LIKE Order.Ordernum
  FIELD CustNum     LIKE Order.CustNum
  FIELD OrderDate   LIKE Order.OrderDate
  FIELD PromiseDate LIKE Order.PromiseDate
  FIELD ShipDate    LIKE Order.ShipDate
  FIELD Carrier     LIKE Order.Carrier
  INDEX OrderNum OrderNum ASCENDING
  INDEX CustNum CustNum ASCENDING.
DEFINE TEMP-TABLE ttInvoice NO-UNDO 
  FIELD Invoicenum  LIKE Invoice.Invoicenum
  FIELD OrderNum    LIKE Invoice.OrderNum
  FIELD Amount      LIKE Invoice.Amount
  FIELD InvoiceDate LIKE Invoice.InvoiceDate
  FIELD ShipCharge  LIKE Invoice.ShipCharge
  FIELD TotalPaid   LIKE Invoice.TotalPaid
  INDEX InvoiceDate InvoiceDate ASCENDING
  INDEX OrderNum OrderNum ASCENDING.

DEFINE DATASET dsOrderLog FOR ttCustomer, ttOrder, ttInvoice
  DATA-RELATION CustOrd FOR ttCustomer,
    ttOrder RELATION-FIELDS(CustNum,CustNum) NESTED 
  DATA-RELATION OrdInv FOR ttOrder,
    ttInvoice RELATION-FIELDS(OrderNum,OrderNum) NESTED.

DEFINE DATA-SOURCE dsCustomer FOR Customer.
DEFINE DATA-SOURCE dsOrder    FOR Order.
DEFINE DATA-SOURCE dsInvoice  FOR Invoice.
BUFFER ttCustomer:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsCustomer:HANDLE).
BUFFER ttOrder:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsOrder:HANDLE).
BUFFER ttInvoice:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsInvoice:HANDLE).