DEFINE VARIABLE dbname AS CHARACTER NO-UNDO LABEL "Database" FORMAT "x(65)".

/* Prompt the user for the name of a demo database to connect. */
SET dbname HELP "Enter the name of your database."
  WITH FRAME dbname-frame SIDE-LABELS.

/* If the entered name does not have the .db suffix, add it. This is necessary
   for the search function to work correctly. */
IF LENGTH(dbname) < 3 THEN
  dbname = dbname + ".db".
ELSE IF SUBSTRING(dbname, LENGTH(dbname) - 2) = ".db" THEN
  dbname = dbname + ".db".

/* If the database does not exist, create it from Sports2000. */
IF SEARCH(dbname) = ? THEN DO:
  MESSAGE "Database does not exist. Do you want to create it?"
    VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Connect Database"
    UPDATE create-it AS LOGICAL.

  IF create-it THEN DO:
    CREATE DATABASE dbname FROM "Sports2000".
    MESSAGE "New database created:" dbname.
  END.
  ELSE UNDO, RETRY.
END.

/* Connect the database. */
CONNECT VALUE(dbname) -1.
