/* r-fof1.p */

DEFINE QUERY custq FOR Customer.

DEFINE BUTTON bprev LABEL "<".
DEFINE BUTTON bnext LABEL ">".

DEFINE FRAME cust-fr SKIP(.5)
  SPACE(8) Customer.Name Customer.CustNum Customer.SalesRep
  Customer.Comments AT COLUMN 6 ROW 13.5
  WITH SIDE-LABELS TITLE "Customer Data" SIZE 80 BY 15 VIEW-AS DIALOG-BOX.

DEFINE FRAME cont-fr SKIP(.5)
  Customer.Address COLON 17 SKIP
  Customer.Address2 COLON 17 SKIP
  Customer.City COLON 17 SKIP
  Customer.State COLON 17 SKIP 
  Customer.PostalCode COLON 17 SKIP
  Customer.Country COLON 17 SKIP
  Customer.Contact COLON 17 SKIP 
  Customer.Phone COLON 17
  WITH SIDE-LABELS TITLE "Contact Informaion" SIZE 40 BY 10 AT COLUMN 1 ROW 3.

DEFINE FRAME ctrl-fr SKIP(.12)
  SPACE(4) bprev bnext
  WITH TITLE "PREVIOUS/NEXT" SIZE 15 BY 2 AT COLUMN 53 ROW 10.5.

DEFINE FRAME acct-fr SKIP(.5)
  Customer.Balance COLON 15 SKIP 
  Customer.CreditLimit COLON 15 SKIP
  Customer.Discount COLON 15 SKIP 
  Customer.Terms COLON 15
  WITH SIDE-LABELS TITLE "Account Information"
  SIZE 38.85 BY 6 AT COLUMN 41 ROW 3.

ON CHOOSE OF bnext DO:
  GET NEXT custq.
  IF NOT AVAILABLE Customer THEN GET FIRST custq.
  RUN display-proc IN THIS-PROCEDURE.
END.

ON CHOOSE OF bprev DO:
  GET PREV custq.
  IF NOT AVAILABLE Customer THEN GET LAST custq.
  RUN display-proc IN THIS-PROCEDURE.
END.

FRAME cont-fr:FRAME = FRAME cust-fr:HANDLE.
FRAME acct-fr:FRAME = FRAME cust-fr:HANDLE.
FRAME ctrl-fr:FRAME = FRAME cust-fr:HANDLE.

OPEN QUERY custq PRESELECT EACH Customer BY Customer.Name.
GET FIRST custq.

RUN display-proc IN THIS-PROCEDURE.
ENABLE ALL WITH FRAME ctrl-fr.
WAIT-FOR WINDOW-CLOSE OF FRAME cust-fr.

PROCEDURE display-proc:
  DISPLAY 
    Customer.Name Customer.CustNum Customer.SalesRep
    Customer.Comments WITH FRAME cust-fr.
  DISPLAY
    Customer.Address Customer.Address2 Customer.City Customer.State
    Customer.PostalCode Customer.Country Customer.Contact Customer.Phone
    WITH FRAME cont-fr.
  DISPLAY 
    Customer.Balance Customer.CreditLimit Customer.Discount Customer.Terms
    WITH FRAME acct-fr.
END PROCEDURE.
