&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW

/* Temp-Table and Buffer definitions                                    */
DEFINE TEMP-TABLE RowObject
       {"dordlne.i"}.


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS vTableWin 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------

  File:

  Description: from viewer.w - Template for SmartDataViewer objects

  Input Parameters:
      <none>

  Output Parameters:
      <none>

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDataViewer
&Scoped-define DB-AWARE no

&Scoped-define ADM-SUPPORTED-LINKS TableIO-Target,Data-Target,Update-Source

/* Include file with RowObject temp-table definition */
&Scoped-define DATA-FIELD-DEFS "dordlne.i"

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME F-Main

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS RowObject.Itemnum RowObject.OrderLineStatus ~
RowObject.Price RowObject.Qty RowObject.Discount 
&Scoped-define ENABLED-TABLES RowObject
&Scoped-define FIRST-ENABLED-TABLE RowObject
&Scoped-define DISPLAYED-TABLES RowObject
&Scoped-define FIRST-DISPLAYED-TABLE RowObject
&Scoped-Define ENABLED-OBJECTS RECT-10 btnBrowseItem btCustomerDiscount ~
btBulkDiscount 
&Scoped-Define DISPLAYED-FIELDS RowObject.Ordernum RowObject.Linenum ~
RowObject.Itemnum RowObject.OrderLineStatus RowObject.Price RowObject.Qty ~
RowObject.Discount RowObject.ExtendedPrice 

/* Custom List Definitions                                              */
/* ADM-ASSIGN-FIELDS,List-2,List-3,List-4,List-5,List-6                 */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON btBulkDiscount 
     LABEL "Bulk" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btCustomerDiscount 
     LABEL "Customer" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnBrowseItem 
     IMAGE-UP FILE "adeicon\u-browse":U
     LABEL "Browse" 
     SIZE-PIXELS 45 BY 28.

DEFINE RECTANGLE RECT-10
     EDGE-PIXELS 3 GRAPHIC-EDGE  NO-FILL 
     SIZE 21 BY 4.33.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME F-Main
     RowObject.Ordernum AT ROW 1 COL 19 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     RowObject.Linenum AT ROW 2.19 COL 19 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 6.2 BY 1
     RowObject.Itemnum AT ROW 3.43 COL 19 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     btnBrowseItem AT Y 45 X 185
     RowObject.OrderLineStatus AT ROW 4.57 COL 19 COLON-ALIGNED
          VIEW-AS COMBO-BOX 
          LIST-ITEMS "Ordered","Back Ordered","Shipped" 
          SIZE 25.6 BY 1
     RowObject.Price AT ROW 1 COL 78 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 20.2 BY 1
     RowObject.Qty AT ROW 2.19 COL 78 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 10.4 BY 1
     RowObject.Discount AT ROW 3.38 COL 78 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 7.6 BY 1
     RowObject.ExtendedPrice AT ROW 4.57 COL 78 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     btCustomerDiscount AT ROW 2.33 COL 107
     btBulkDiscount AT ROW 3.95 COL 107
     RECT-10 AT ROW 1.52 COL 104
     "Discounts" VIEW-AS TEXT
          SIZE 9 BY .81 AT ROW 1 COL 110
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1 SCROLLABLE .


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDataViewer
   Data Source: "dordlne.w"
   Allow: Basic,DB-Fields
   Frames: 1
   Add Fields to: Neither
   Other Settings: PERSISTENT-ONLY COMPILE
   Temp-Tables and Buffers:
      TABLE: RowObject D "?" ?  
      ADDITIONAL-FIELDS:
          {dordlne.i}
      END-FIELDS.
   END-TABLES.
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT."
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW vTableWin ASSIGN
         HEIGHT             = 5.19
         WIDTH              = 126.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB vTableWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/viewer.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW vTableWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME F-Main
   NOT-VISIBLE Size-to-Fit Custom                                       */
ASSIGN 
       FRAME F-Main:SCROLLABLE       = FALSE
       FRAME F-Main:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN RowObject.ExtendedPrice IN FRAME F-Main
   NO-ENABLE                                                            */
ASSIGN 
       RowObject.ExtendedPrice:READ-ONLY IN FRAME F-Main        = TRUE.

/* SETTINGS FOR FILL-IN RowObject.Linenum IN FRAME F-Main
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN RowObject.Ordernum IN FRAME F-Main
   NO-ENABLE                                                            */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main
/* Query rebuild information for FRAME F-Main
     _Options          = "NO-LOCK"
     _Query            is NOT OPENED
*/  /* FRAME F-Main */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME btBulkDiscount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btBulkDiscount vTableWin
ON CHOOSE OF btBulkDiscount IN FRAME F-Main /* Bulk */
DO:

    DEFINE VARIABLE iCustomerDiscount   AS INTEGER NO-UNDO.
    DEFINE VARIABLE iBulkDiscount       AS INTEGER NO-UNDO.

    FIND order WHERE order.ordernum = 
        INTEGER(RowObject.Ordernum:SCREEN-VALUE) NO-LOCK NO-ERROR.
    IF AVAILABLE order THEN DO:
        FIND customer WHERE customer.custnum = order.custnum NO-LOCK NO-ERROR.
        IF AVAILABLE customer THEN DO:
            iCustomerDiscount = customer.discount.
        END. /* available customer */
    END. /* available order */
    
    FIND item WHERE item.itemnum = 
        INTEGER(RowObject.linenum:SCREEN-VALUE) NO-LOCK NO-ERROR.
    IF AVAILABLE item THEN DO:
        iBulkDiscount = TRUNCATE(INTEGER(RowObject.qty:SCREEN-VALUE) / item.minqty, 0).
    END.
    
    
    ASSIGN RowObject.Discount:SCREEN-VALUE = STRING(iCustomerDiscount + iBulkDiscount).
    RUN calculatePrice.

        
        

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btCustomerDiscount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btCustomerDiscount vTableWin
ON CHOOSE OF btCustomerDiscount IN FRAME F-Main /* Customer */
DO:
    FIND order WHERE order.ordernum = 
        INTEGER(RowObject.Ordernum:SCREEN-VALUE) NO-LOCK NO-ERROR.
    IF AVAILABLE order THEN DO:
        FIND customer WHERE customer.custnum = order.custnum NO-LOCK NO-ERROR.
        IF AVAILABLE customer THEN DO:
            ASSIGN RowObject.Discount:SCREEN-VALUE = STRING(customer.discount).
            RUN calculatePrice.
        END. /* available customer */
    END. /* available order */
      
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnBrowseItem
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnBrowseItem vTableWin
ON CHOOSE OF btnBrowseItem IN FRAME F-Main /* Browse */
DO:
  DEFINE VARIABLE lItemNum AS INTEGER NO-UNDO.
  lItemNum = INTEGER(RowObject.itemnum:SCREEN-VALUE IN FRAME {&FRAME-NAME}).
  RUN gselitem.w(INPUT-OUTPUT lItemNum).
  RowObject.ItemNum:SCREEN-VALUE IN FRAME {&FRAME-NAME} = STRING(lItemNum).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RowObject.Discount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RowObject.Discount vTableWin
ON LEAVE OF RowObject.Discount IN FRAME F-Main /* Discount */
DO:
  IF SELF:MODIFIED THEN DO:
    RUN calculatePrice.
  END.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RowObject.Itemnum
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RowObject.Itemnum vTableWin
ON LEAVE OF RowObject.Itemnum IN FRAME F-Main /* Item Num */
DO:
 DEFINE VARIABLE cnewrec AS CHARACTER NO-UNDO.
 {get NewRecord cnewrec}.
    IF cnewrec = "Add" THEN DO:
         FIND item where item.itemnum = INTEGER(rowobject.itemnum:SCREEN-VALUE)
         NO-LOCK NO-ERROR.
         IF AVAIL item THEN 
         RowObject.price:SCREEN-VALUE = STRING(item.price).

    END. /*cnrereq = "add"*/

END. /*leave*/

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RowObject.Price
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RowObject.Price vTableWin
ON LEAVE OF RowObject.Price IN FRAME F-Main /* Price */
DO:
  IF SELF:MODIFIED THEN DO:
    RUN calculatePrice.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RowObject.Qty
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RowObject.Qty vTableWin
ON LEAVE OF RowObject.Qty IN FRAME F-Main /* Qty */
DO:
  IF SELF:MODIFIED THEN DO:
    RUN calculatePrice.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK vTableWin 


/* ***************************  Main Block  *************************** */

  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          
    RUN initializeObject.
  &ENDIF         
  
  /************************ INTERNAL PROCEDURES ********************/

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE calculateprice vTableWin 
PROCEDURE calculateprice :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

DO WITH FRAME {&FRAME-NAME}:
    RowObject.ExtendedPrice:SCREEN-VALUE = 
        STRING(INTEGER(Price:SCREEN-VALUE) * INTEGER(Qty:SCREEN-VALUE)
                             * (1 - (INTEGER(RIGHT-TRIM(Discount:SCREEN-VALUE, '%')) / 100))).
                               
END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE collectChanges vTableWin 
PROCEDURE collectChanges :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT-OUTPUT PARAMETER pcChanges AS CHARACTER NO-UNDO.
    DEFINE INPUT-OUTPUT PARAMETER pcInfo    AS CHARACTER NO-UNDO.
  
    DEFINE VARIABLE iPosition         AS INTEGER      NO-UNDO.
    DEFINE VARIABLE iCount            AS INTEGER      NO-UNDO.
    DEFINE VARIABLE iLineNum          AS INTEGER      NO-UNDO.
    DEFINE VARIABLE hDataSource       AS HANDLE       NO-UNDO.
    DEFINE VARIABLE cForeignFields    AS CHARACTER    NO-UNDO.
    DEFINE VARIABLE cForeignValues    AS CHARACTER    NO-UNDO.
    DEFINE VARIABLE cList             AS CHARACTER    NO-UNDO.
    DEFINE VARIABLE cResult           AS CHARACTER    NO-UNDO.
    DEFINE BUFFER bOrderLine FOR orderline .
    
    {get NewRecord cResult}.
    IF cResult NE "No":U THEN DO:    /* Could be Add or Copy or No */
     
        {get DataSource hDataSource}.
        {get ForeignFields cForeignFields hDataSource}.
        {get ForeignValues cForeignValues hDataSource}.
  
        DO iCount = 1 TO NUM-ENTRIES(cForeignValues):
            ASSIGN cList = cList + (IF cList EQ "":U THEN "":U ELSE CHR(1)) +
                ENTRY(iCount * 2, cForeignFields) + CHR(1) + ENTRY(iCount, cForeignValues). 
        END.   /* END DO iCount */
    
        iPosition = LOOKUP('ordernum', cForeignFields) / 2. 
        FIND LAST bOrderLine WHERE bOrderLine.OrderNum = 
            INTEGER(ENTRY(iPosition, cForeignValues)) NO-LOCK NO-ERROR.
        IF AVAILABLE bOrderLine THEN
            iLineNum = bOrderLine.linenum + 1.
        ELSE
            iLineNum = 1.
    
        cList = cList + (IF cList EQ "":U THEN "":U ELSE CHR(1)) + 'linenum' +
            CHR(1) + STRING(iLineNum).
    END. /* ADD OR COPY RECORD */

  
    RUN SUPER( INPUT-OUTPUT pcChanges, INPUT-OUTPUT pcInfo).
  
    IF cList NE "":U THEN DO:
        iPosition = LOOKUP(STRING(TARGET-PROCEDURE), pcInfo).
        IF iPosition NE 0 THEN DO:
            ENTRY(iPosition - 2, pcInfo) = 
                STRING(INTEGER(ENTRY(iPosition - 2, pcInfo)) + (NUM-ENTRIES(cList, CHR(1)) / 2)).
            pcChanges = pcChanges + (IF pcChanges EQ "":U THEN "":u ELSE CHR(1)) + cList.
        END.
    END.
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disableFields vTableWin 
PROCEDURE disableFields :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER pcFieldType AS CHARACTER NO-UNDO.

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER( INPUT pcFieldType).

  /* Code placed here will execute AFTER standard behavior.    */
  btnBrowseItem:SENSITIVE IN FRAME {&FRAME-NAME} = FALSE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI vTableWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME F-Main.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enableFields vTableWin 
PROCEDURE enableFields :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */
 btnBrowseItem:SENSITIVE IN FRAME {&FRAME-NAME} = TRUE.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

