/* i-incus.p - Import the Customer table from an xml file */

DEFINE VARIABLE hDoc   AS HANDLE  NO-UNDO.
DEFINE VARIABLE hRoot  AS HANDLE  NO-UNDO.
DEFINE VARIABLE hTable AS HANDLE  NO-UNDO.
DEFINE VARIABLE hField AS HANDLE  NO-UNDO.
DEFINE VARIABLE hText  AS HANDLE  NO-UNDO.
DEFINE VARIABLE hBuf   AS HANDLE  NO-UNDO.
DEFINE VARIABLE hDBFld AS HANDLE  NO-UNDO.
DEFINE VARIABLE ix     AS INTEGER NO-UNDO.
DEFINE VARIABLE jx     AS INTEGER NO-UNDO.

/* So we can create new recs */
DEFINE TEMP-TABLE ttCustomer LIKE Customer.

CREATE X-DOCUMENT hDoc.
CREATE X-NODEREF hRoot.
CREATE X-NODEREF hTable.
CREATE X-NODEREF hField.
CREATE X-NODEREF hText.

hBuf = BUFFER ttCustomer:HANDLE.

/* Read in the file created in the last example */
hDoc:LOAD("file", "cust.xml", FALSE).  
hDoc:GET-DOCUMENT-ELEMENT(hRoot).

/* Read each Customer from the root */
REPEAT ix = 1 TO hRoot:NUM-CHILDREN:
  hRoot:GET-CHILD(hTable, ix).
  CREATE ttCustomer.

  /* Get the fields given as attributes */
  ttCustomer.CustNum = INTEGER(hTable:GET-ATTRIBUTE("CustNum")).
  ttCustomer.Name    = hTable:GET-ATTRIBUTE("Name").

  /* Get the remaining fields given as elements with text */
  REPEAT jx = 1 TO hTable:NUM-CHILDREN:
    hTable:GET-CHILD(hField, jx).
    IF hField:NUM-CHILDREN < 1 THEN NEXT. /* Skip any null value */
    hDBFld = hBuf:BUFFER-FIELD(hField:NAME).
    hField:GET-CHILD(hText, 1).           /* Get the text value of the field */
    hDBFld:BUFFER-VALUE = hTEXT:NODE-VALUE.
  END.
END.

DELETE OBJECT hDoc.
DELETE OBJECT hRoot.
DELETE OBJECT hTable.
DELETE OBJECT hField.
DELETE OBJECT hText.

/* Show data made it by displaying temp-table */
FOR EACH ttCustomer:
  DISPLAY ttCustomer.NAME.
END.
