/* i-sax1d.p */
DEFINE VARIABLE hParser  AS HANDLE NO-UNDO.
DEFINE VARIABLE hHandler AS HANDLE NO-UNDO.

/* Create the SAX-READER object */
CREATE SAX-READER hParser.

/* Run the persistent procedure that contains the callbacks */
RUN "i-sax1h.p" PERSISTENT SET hHandler.

/* Give the SAX-READER the handle to the persistent procedure */
hParser:HANDLER = hHandler.

/* Give the SAX-READER the info on the file to parse.
   This XML file does not use namespaces. */
hParser:SET-INPUT-SOURCE("FILE", "i-sax1.xml").
hParser:SAX-PARSE( ) NO-ERROR.

/* By the time SAX-PARSE returns, our callbacks have been called as many
   times as necessary and were done processing the XML document (or there
   was an error) */
IF ERROR-STATUS:ERROR THEN DO:
  IF ERROR-STATUS:NUM-MESSAGES > 0 THEN
    /* Unable to begin the parse */
    MESSAGE ERROR-STATUS:GET-MESSAGE(1) VIEW-AS ALERT-BOX.
  ELSE
    /* Error detected in a callback */
    MESSAGE RETURN-VALUE VIEW-AS ALERT-BOX.
END.
ELSE
  MESSAGE "Document parsed successfully" VIEW-AS ALERT-BOX.
  
DELETE OBJECT hParser.
DELETE PROCEDURE hHandler.
