/* pi-tfx-read-1b.p */
/* Provides XML Schema for a new dynamic temp-table. */

{pi-tfx-parameterVarDefs.i}
    
DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.
DEFINE VARIABLE httFeedback AS HANDLE  NO-UNDO.

CREATE TEMP-TABLE httFeedback.
    
ASSIGN
  cSourceType             = "FILE"
  cFile                   = "ttFeedback.xsd"
  lOverrideDefaultMapping = ?
  cFieldTypeMapping       = "Comments, CLOB"
  cVerifySchemaMode       = ?.

DISPLAY "Is dynamic temp-table PREPARED? " httFeedback:PREPARED SKIP.
DISPLAY "Reading XML Schema..." SKIP.
    
returnValue = httFeedback:READ-XMLSCHEMA(cSourceType, cFile,
                                         lOverrideDefaultMapping,
                                         cFieldTypeMapping, cVerifySchemaMode).

IF returnValue THEN DO:
  DISPLAY "Is dynamic temp-table now PREPARED? " httFeedback:PREPARED SKIP.
  DISPLAY "What is the data type of the Comments field? "
    httFeedback:DEFAULT-BUFFER-HANDLE:BUFFER-FIELD("Comments"):DATA-TYPE.
END.
