/* pi-tfx-read-7.p */
/* Populates a static ProDataSet with records from an XML file. */

{pi-tfx-parameterVarDefs.i}
{pi-tfx-ttSetup-7.i}

DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.
DEFINE VARIABLE hPDS        AS HANDLE  NO-UNDO.

DEFINE DATASET dsCustomerOrders FOR ttCust, ttOrd
  DATA-RELATION custOrd FOR ttCust, ttOrd 
    RELATION-FIELDS(custNum, CustNum) NESTED.

hPDS = DATASET dsCustomerOrders:HANDLE.

ASSIGN
  cSourceType             = "FILE"
  cFile                   = "dsCustomerOrders.xml"
  cReadMode               = "EMPTY"
  cSchemaLocation         = ?
  lOverrideDefaultMapping = FALSE.

returnValue = hPDS:READ-XML (cSourceType, cFile, cReadMode,
                             cSchemaLocation, lOverrideDefaultMapping).

IF returnValue THEN DO:
  FOR EACH ttCust BY CustNum: 
    FOR EACH ttOrd WHERE ttOrd.CustNum = ttCust.CustNum:
      DISPLAY ttCust.CustNum ttCust.NAME FORMAT "x(30)" ttOrd.OrderNum.
    END.
  END.
END.
