/* pi-tfx-write-6a.p */
/* Writes data from a static ProDataSet to an XML file. This demonstrates 
   the first half of a persistent storage mechanism through XML. */

{pi-tfx-parameterVarDefs.i}
{pi-tfx-writeSetup-6.i}

DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.
DEFINE VARIABLE hPDS        AS HANDLE  NO-UNDO.

hPDS = DATASET dsCustomerOrders:HANDLE.
    
ASSIGN
  cTargetType       = "FILE"
  cFile             = "dsCustomerOrder.xml"
  lFormatted        = TRUE
  cEncoding         = ?
  cSchemaLocation   = ?
  lWriteSchema      = TRUE
  lMinSchema        = FALSE
  lWriteBeforeImage = TRUE.

/*** Before the method call, your application does work with its data. ***/

returnValue = hPDS:WRITE-XML (cTargetType, cFile, lFormatted, cEncoding, 
                              cSchemaLocation, lWriteSchema, lMinSchema, 
                              lWriteBeforeImage).

IF NOT returnValue THEN DO:
  MESSAGE "WRITE-XML on ProDataSet failed!" VIEW-AS ALERT-BOX.
  RETURN.
END.
ELSE 
  MESSAGE "Successful WRITE-XML on : " hPDS:NAME VIEW-AS ALERT-BOX.
