/* pi-tfx-writeSetup-6.i */
/* Creates two new static temp-tables and a ProDataSet. */

/* Definition for Temp-Table ttCust */
DEFINE TEMP-TABLE ttCust NO-UNDO BEFORE-TABLE ttCustBef
  FIELD CustNum LIKE Customer.CustNum
  FIELD Name LIKE Customer.Name 
    COLUMN-LABEL "Loyal Customer"
    XML-NODE-TYPE "Attribute"
  FIELD Country LIKE Customer.Country
  FIELD Comments LIKE Customer.Comments FORMAT "x(40)"
  INDEX CustNum IS PRIMARY UNIQUE CustNum
  INDEX Name Name
  INDEX Comments IS WORD-INDEX Comments.

/* Definition for Temp-Table ttOrder */
DEFINE TEMP-TABLE ttOrd BEFORE-TABLE ttOrdBef
  FIELD OrderNum LIKE Order.OrderNum
  FIELD CustNum LIKE Order.CustNum
  FIELD OrderDate LIKE Order.OrderDate
  INDEX OrderNum IS PRIMARY UNIQUE OrderNum
  INDEX CustOrder IS UNIQUE CustNum OrderNum
  INDEX OrderDate OrderDate.

DEFINE DATASET dsCustomerOrders FOR ttCust, ttOrd
  DATA-RELATION custOrd FOR ttCust, ttOrd 
    REPOSITION RELATION-FIELDS (CustNum, CustNum) NESTED.
