/* sax-readwrite2.p - This sample shows a programatically created SAX-attributes 
   object used to override the attributes of the input XML document. */
DEFINE VARIABLE hSAXWriter       AS HANDLE NO-UNDO.
DEFINE VARIABLE hSAXReader       AS HANDLE NO-UNDO.
DEFINE VARIABLE hMySAXAttributes AS HANDLE NO-UNDO.

CREATE SAX-WRITER hSAXWriter.
hSAXWriter:FORMATTED = TRUE.
hSAXWriter:STANDALONE = TRUE.
hSAXWriter:ENCODING = "UTF-8".
hSAXWriter:SET-OUTPUT-DESTINATION("FILE", "sax-readwrite2.xml").

hSAXWriter:START-DOCUMENT().
CREATE SAX-ATTRIBUTES hMySAXattributes.
hMySAXAttributes:INSERT-ATTRIBUTE("MailDate", STRING(TODAY)).
hMySAXAttributes:INSERT-ATTRIBUTE("Catalog", "Yes").

CREATE SAX-READER hSAXReader.
hSAXReader:SET-INPUT-SOURCE("FILE", "sampledata.xml").
hSAXReader:SAX-PARSE().
hSAXWriter:END-DOCUMENT().

DELETE OBJECT hSAXWriter.
DELETE OBJECT hSAXReader.
DELETE OBJECT hMySAXAttributes.

/* Callback procedures for SAX parser (SAX-reader object) */
PROCEDURE StartElement:
  DEFINE INPUT PARAMETER namespaceURI   AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER localName      AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER qName          AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER hSAXAttributes AS HANDLE    NO-UNDO.

  /* Only call SAX-writer with attributes for address elements. */
  IF locaLNAME = "Address" THEN 
    hSAXWriter:START-ELEMENT(localName, namespaceURI, hMySAXAttributes).
  ELSE   
    hSAXWriter:START-ELEMENT(localName, namespaceURI).
END.

PROCEDURE Characters:
  DEFINE INPUT PARAMETER charData AS MEMPTR  NO-UNDO.
  DEFINE INPUT PARAMETER numChars AS INTEGER NO-UNDO.

  DEFINE VARIABLE data AS CHARACTER NO-UNDO.
  ASSIGN data = GET-STRING(charData, 1, GET-SIZE(charData)).

  hSAXWriter:WRITE-CHARACTERS(data).
END.

PROCEDURE EndElement:
  DEFINE INPUT PARAMETER namespaceURI AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER localName    AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER qName        AS CHARACTER NO-UNDO.
 
  hSAXWriter:END-ELEMENT(localName, namespaceURI).
END.
