 
 /*------------------------------------------------------------------------
    File        : bePurchaseOrder
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : 
    Created     : Fri Jul 27 11:20:47 EDT 2007
    Notes       : 
  ----------------------------------------------------------------------*/
using openedge.tutorial.services.*.

CLASS openedge.tutorial.services.BEPurchaseOrder inherits BusinessEntity  : 
    
    constructor public BEPurchaseOrder():
        def var hBuffer as handle extent 10 no-undo.
        def var hDataTable as handle extent 10 no-undo.
        def var hDataSource as handle extent 10 no-undo.
        def var hDataset as handle no-undo.

        hBuffer[1] = BuildBuffer("PurchaseOrder").
        hBuffer[2] = BuildBuffer("POLine").
        hBuffer[3] = BuildBuffer("Item").
        hBuffer[4] = BuildBuffer("Supplier").

    	/* create data tables and prodataset */
        hDataTable[1] = BuildDataTable(hBuffer[1]).
        hDataTable[2] = BuildDataTable(hBuffer[2]).
        hDataTable[3] = BuildDataTable(hBuffer[3]).
        hDataTable[4] = BuildDataTable(hBuffer[4]).
              
    	/* create prodataset */
        create dataset hDataset.
        hDataset:name = 'PurchOrder'.
        DatasetHandle = hDataset.
        DatasetName = hDataset:name.
        
        AddTable(DatasetHandle, hDataTable[1], hBuffer[1], '', ?).
        AddTable(DatasetHandle, hDataTable[2], hBuffer[2], 'PONum,PONum', hDataTable[1]).
        AddTable(DatasetHandle, hDataTable[3], hBuffer[3], 'ItemNum,ItemNum', hDataTable[2]).
        AddTable(DatasetHandle, hDataTable[4], hBuffer[4], 'SupplierIDNum,SupplierIDNum', hDataTable[1]).
    end constructor.
    
    method public void Callback_ePurchaseOrder_RowCreate (dataset-handle DatasetHandle):
        def var hBuffer as handle no-undo.
        def var hBuffer2 as handle no-undo.
        def var iPONum as integer no-undo.
        
        hBuffer = DatasetHandle:get-buffer-handle('ePurchaseOrder').
        create buffer hBuffer2 for table hBuffer buffer-name 'local'.
        
        hBuffer2:find-last() no-error.
        if hBuffer2:available then
            iPONum = hBuffer2::PONum + 1.
        else
            iPONum = 1.
        
        hBuffer::PONum = iPONum.                     
        
        delete object hBuffer2.
    end method.    /* callback_ePurchaseOrder_RowCreate */          

    method override public void RegisterCallbacks():
        def var hBuffer as handle no-undo.
        
        hBuffer = DatasetHandle:get-buffer-handle('ePurchaseOrder').
        hBuffer:set-callback('Row-Create', 'Callback_ePurchaseOrder_RowCreate').
    end method.    /*registerCallbacks*/
END CLASS.