 /*------------------------------------------------------------------------
    File        : ServiceAdapter
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : 
    Created     : Tue Jul 03 11:40:35 EDT 2007
    Notes       : 
  ----------------------------------------------------------------------*/
using openedge.tutorial.services.*.

CLASS openedge.tutorial.services.ServiceAdapter:
         
    def private var hQuery as handle no-undo. 
    def private var hBuffer as handle no-undo.
    def private var oService as Service no-undo.
    def private var oEntity as BusinessEntity no-undo.
    def private var hEntity as handle no-undo.
    def private property EntityName as character no-undo
        get.
        set.

	constructor public ServiceAdapter ():
	    oService = Service:GetInstance().
	    oService:RegisterServiceAdapter(this-object).
    end constructor.
    
	CONSTRUCTOR PUBLIC ServiceAdapter ( input pcEntityName as character ):
        this-object().
        
        EntityName = pcEntityName.
        oEntity = oService:GetEntity(pcEntityName).
        oEntity:RegisterCallbacks().
        hEntity = oEntity:DatasetHandle.
	    hBuffer = hEntity:get-buffer-handle(1).
	    CreateQuery().
	END CONSTRUCTOR.
    
    method public void StopService ():
        /* Only kill service if we're the last adapter attached */
        if oService:NumRegisteredAdapters eq 0 then
            delete object oService.
    end method.
            	
	method private void CreateQuery():
	    create query hQuery.
	    hQuery:set-buffers(hBuffer).
	end method.
	
	method public handle GetDatasetHandle():
	    return hEntity.
	end method.
	
    method public void CloseQuery():
        if valid-handle(hQuery) and hQuery:is-open then
            hQuery:query-close().        
    end method.    /* closequery */
    
    destructor public ServiceAdapter ():
        CloseQuery().
        delete object hQuery no-error.
        
        oService:UnregisterServiceAdapter(this-object).
        StopService().
    end destructor.
    
    method public void SaveData():
        oService:SaveData(hEntity).
    end method.   
    
    method public void RemoveRecord (phBuffer as handle):
        def var hQuery as handle.
        def var iRow as integer.
        
        hQuery = phBuffer:query.
        iRow = hQuery:current-result-row * 1.
        phBuffer:buffer-delete() no-error.
                
        hQuery:delete-result-list-entry().
        hQuery:reposition-to-row(iRow).
    end method.    /* removeRecord */
    
    method public void AddRecord (phBuffer as handle):
        def var hQuery as handle.
        def var rRowid as rowid.
        
        hQuery = phBuffer:query.
                
        phBuffer:buffer-create() no-error.
        rRowid = phBuffer:rowid.
                
        hQuery:create-result-list-entry().
        hQuery:reposition-to-rowid(rRowid).
    end method.    /* addRecord */
    
    method public void CancelUpdate (phBuffer as handle):
        phBuffer:reject-changes().
    end method.    /* cancelUpdate */
    
END CLASS.